Gecode::Gist Namespace Reference

The Gecode Interactive Search Tool. More...

## Namespaces

namespace | LayoutConfig
| Parameters for the tree layout.

## Classes

class | Inspector
| Abstract base class for inspectors. More...
class | Comparator
| Abstract base class for comparators. More...
class | TextOutput
| An window for simple text output. More...
class | Print
| An inspector for printing simple text output. More...
class | VarComparator
| A simple comparator. More...
class | Options
| Options for Gist More...
class | DrawingCursor
| A cursor that draws a tree on a QWidget. More...
class | Logos
| Class holding Gecode and Gist logo icons. More...
class | LayoutCursor
| A cursor that computes a tree layout for VisualNodes. More...
class | AboutGist
| Display information about Gist. More...
class | GistMainWindow
| Main window for stand-alone Gist. More...
class | NodeAllocatorBase
| Node allocator. More...
class | Node
| Base class for nodes of the search tree. More...
class | NodeCursor
| A cursor that can be run over a tree. More...
class | HideFailedCursor
| A cursor that marks failed subtrees as hidden. More...
class | UnhideAllCursor
| A cursor that marks all nodes in the tree as not hidden. More...
class | UnstopAllCursor
| A cursor that marks all nodes in the tree as not stopping. More...
class | NextSolCursor
| A cursor that finds the next solution. More...
class | StatCursor
| A cursor that collects statistics. More...
class | BranchLabelCursor
| A cursor that labels branches. More...
class | DisposeCursor
| A cursor that frees all memory. More...
class | NodeStatInspector
| Display information about nodes. More...
class | NodeVisitor
| Base class for a visitor that runs a cursor over a tree. More...
class | PostorderNodeVisitor
| Run a cursor over a tree, processing nodes in post-order. More...
class | PreorderNodeVisitor
| Run a cursor over a tree, processing nodes in pre-order. More...
class | NodeWidget
| Small node drawings for the status bar. More...
class | PreferencesDialog
| Preferences dialog for Gist. More...
class | Gist
| Gecode Interactive Search Tool More...
class | Branch
| Representation of a branch in the search tree. More...
class | Statistics
| Statistics about the search tree More...
class | BestNode
| Static reference to the currently best space. More...
class | SpaceNode
| A node of a search tree of Gecode spaces. More...
class | StopChoice
| Choice for StopBrancher More...
class | StopBrancher
| Brancher that stops exploration in Gist More...
class | GistOutputStream
| An outputstream that prints on a QTextEdit. More...
class | TextOutputI
| Window with associated ostream, used for inspecting Gist nodes. More...
class | SearchItem
| A stack item for depth first search. More...
class | SearcherThread
| A thread that concurrently explores the tree. More...
class | TreeCanvas
| A canvas that displays the search tree. More...
class | ShapeAllocator
| Allocate shapes statically. More...
class | Layouter
| Helper functions for the layout algorithm. More...
class | Layout
| Layout parameters More...
class | BoundingBox
| Bounding box. More...
class | Extent
| Extent representing shape of a tree at one depth level More...
class | Shape
| The shape of a subtree. More...
class | VisualNode
| Node class that supports visual layout More...

## Enumerations

enum | NodeStatus { SOLVED , FAILED , BRANCH , UNDETERMINED , STOP , UNSTOP }
| Status of nodes in the search tree. More...

## Functions

void | stopBranch (Space &home)
| A branching that stops exploration.
int | explore (Space *root, bool bab, const Options &opt)
| Create a new stand-alone Gist for root using bab.
int | dfs (Space *root, const Gist::Options &opt=Gist::Options::def)
| Create a new stand-alone Gist for root.
int | bab (Space *root, const Gist::Options &opt=Gist::Options::def)
| Create a new stand-alone Gist for branch-and-bound search of root.

## Variables

const double | nodeWidth = 20.0
const double | halfNodeWidth = nodeWidth / 2.0
const double | failedWidth = 14.0
const double | halfFailedWidth = failedWidth / 2.0
const double | quarterFailedWidthF = failedWidth / 4.0
const double | shadowOffset = 3.0
const double | hiddenDepth
ShapeAllocator | shapeAllocator
| Allocate shapes statically.
const unsigned char | zoomToFitIcon []

## Detailed Description

The Gecode Interactive Search Tool.

The Gecode::Gist namespace contains the Gecode Interactive Search Tool, a Qt-based graphical search engine.

## Enumeration Type Documentation

## NodeStatus

enum Gecode::Gist::NodeStatus

Status of nodes in the search tree.

Enumerator
SOLVED | Node representing a solution.
FAILED | Node representing failure.
BRANCH | Node representing a branch.
UNDETERMINED | Node that has not been explored yet.
STOP | Node representing stop point.
UNSTOP | Node representing ignored stop point.

Definition at line 44 of file spacenode.hh.

## Function Documentation

## stopBranch()

void Gecode::Gist::stopBranch | ( | Space & | home | ) |

A branching that stops exploration.

Definition at line 127 of file gist.cpp.

## explore()

int Gecode::Gist::explore | ( | Space * | root,
|  | bool | bab,
|  | const Options & | opt )

Create a new stand-alone Gist for root using bab.

Definition at line 102 of file gist.cpp.

## Variable Documentation

## nodeWidth

const double Gecode::Gist::nodeWidth = 20.0

Definition at line 56 of file drawingcursor.cpp.

## halfNodeWidth

const double Gecode::Gist::halfNodeWidth = nodeWidth / 2.0

Definition at line 57 of file drawingcursor.cpp.

## failedWidth

const double Gecode::Gist::failedWidth = 14.0

Definition at line 58 of file drawingcursor.cpp.

## halfFailedWidth

const double Gecode::Gist::halfFailedWidth = failedWidth / 2.0

Definition at line 59 of file drawingcursor.cpp.

## quarterFailedWidthF

const double Gecode::Gist::quarterFailedWidthF = failedWidth / 4.0

Definition at line 60 of file drawingcursor.cpp.

## shadowOffset

const double Gecode::Gist::shadowOffset = 3.0

Definition at line 61 of file drawingcursor.cpp.

## hiddenDepth

const double Gecode::Gist::hiddenDepth

Initial value:
=
static_cast<double>(Layout::dist_y) + failedWidth
Gecode::Gist::Layout::dist_y
static const int dist_y
Definition visualnode.hh:46
Gecode::Gist::failedWidth
const double failedWidth
Definition drawingcursor.cpp:58

Definition at line 62 of file drawingcursor.cpp.

## shapeAllocator

ShapeAllocator Gecode::Gist::shapeAllocator

Allocate shapes statically.

Definition at line 67 of file visualnode.cpp.

## zoomToFitIcon

const unsigned char Gecode::Gist::zoomToFitIcon[]

Definition at line 36 of file zoomToFitIcon.hpp.